import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;


public class SimpleSocketServer {

	
	ServerSocket server = new ServerSocket(1234);
	
	boolean close=false;
	
	boolean waitingForOperation = true;
	File outFile;
	int currentType;
	int currentBodyLength;
	DataOutputStream outFileStream;
	
	
	SimpleSocketServer() throws IOException{
		while(true){
			Socket client = server.accept();
			InputStream inputStream = client.getInputStream();
			OutputStream outputStream = client.getOutputStream();
			DataInputStream dis = new DataInputStream(inputStream);
			DataOutputStream dos = new DataOutputStream(outputStream);
			
			System.out.println("Connected ");

			
			while(!close){

				if(dis.available()>0){
					
					if(waitingForOperation==true){
						int operationType = dis.read();
						if(operationType == 1){
							currentType = 1;
							waitingForOperation = false;
						}else if(operationType == 2){
							
							currentType = 2;
							if(dis.available() > 4){
								currentBodyLength = dis.readInt();
							}
							waitingForOperation = false;
						}
						
					}else{
						
						
						if(currentType == 1){
							if(currentBodyLength>0){
								if(dis.available()>=currentBodyLength){
									String path = dis.readUTF();
									dos.write(1);
									outFile = new File(path);
								      if(outFile.exists()){

								    	  dos.writeLong(outFile.length());
								      }else{
								    	  dos.writeLong(0);

								      }
									

									
									dos.flush();
									currentType = 0;
									currentBodyLength = 0;
									waitingForOperation = true;
								}
							}else{
								// Check if we can read the body content length
								if(dis.available() > 4){
									currentBodyLength = dis.read();
								}
							}
						}else if(currentType == 2){

							if(currentBodyLength>0){
								if(dis.available()>=currentBodyLength){

									
									byte[] data = new byte[currentBodyLength];
									dis.read(data);
									
									
									try {
										
										 if(outFile.exists()){
											 outFileStream = new DataOutputStream(new FileOutputStream(outFile, true));
									      } else {
									    	  outFileStream = new DataOutputStream(new FileOutputStream(outFile));
									      }

										 	outFileStream.write(data);
										 	
									    } catch (FileNotFoundException ex) {
									    	System.out.println("File Error");
									    } catch (IOException ex) {
									    	System.out.println("IO Eroor");
									    }
									
									
									dos.write(1);
								    dos.writeLong(outFile.length());
									dos.flush();

									currentType = 0;
									waitingForOperation = true;
									currentBodyLength = 0;
								}
							}else{
								// Check if we can read the body content length
								if(dis.available() > 4){
									currentBodyLength = dis.readInt();
								}
							}
						}else if(currentType==3){
							//We`re done
							outFileStream.close();
							inputStream.close();
							outputStream.close();
							dis.close();
							dos.close();
							client.close();
							
						}
					}
					
				}else{
					//System.out.println("No Bytes");
				}
			}
		}
	}
	
	
	public static void main(String[] args){
		try{
			SimpleSocketServer server = new SimpleSocketServer();
		}catch(IOException e){
			System.out.print(e);
		}
	}
	
	
}
